--[[
Author: Starinnia
CPR is a combo points display addon based on Funkydude's BasicComboPoints
SoulShards.lua - A module for tracking Soul Shards
$Date: $
$Revision: -1 $
Project Version: r146
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2010 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(2, UnitClass("player")) ~= "WARLOCK" then return end

local cpr = LibStub("AceAddon-3.0"):GetAddon("ComboPointsRedux")
local modName = "Soul Shards"
local SoulShardModule = cpr:NewModule(modName, "AceConsole-3.0", "AceEvent-3.0")
SoulShardModule.MAX_POINTS = 3
SoulShardModule.displayName = GetSpellInfo(87388)
SoulShardModule.abbrev = "SS"

function SoulShardModule:OnInitialize()
	self.graphics = cpr:MakeGraphicsFrame(modName, self.MAX_POINTS)
	self.text = cpr:MakeTextFrame(modName)
end

function SoulShardModule:OnEnable()
	if not cpr.db.profile.modules[modName].disableGraphics then
		self.graphics:Show()
	end
	if not cpr.db.profile.modules[modName].disableText then
		self.text:Show()
	end
	
	self:RegisterEvent("UNIT_POWER", "Update")
	self:RegisterEvent("UNIT_DISPLAYPOWER", "Update")
end

function SoulShardModule:OnDisable()
	self.graphics:Hide()
	self.text:Hide()
	self:UnregisterAllEvents()
end

function SoulShardModule:Update()
	local count = UnitPower("player", SPELL_POWER_SOUL_SHARDS)
	
	if count > 0 then
		local r, g, b = cpr:GetColorByPoints(modName, count)
		for i = count, 1, -1 do
			self.graphics.points[i].icon:SetVertexColor(r, g, b)
			self.graphics.points[i]:Show()
		end
		for j = self.MAX_POINTS, count+1, -1 do
			self.graphics.points[j]:Hide()
		end
		self.text:SetNumPoints(count)
	else
		for i = 1, self.MAX_POINTS do
			self.graphics.points[i]:Hide()
		end
		self.text:SetNumPoints("")
	end
end
